"use strict";
(self["webpackChunkjupyterlab_wipp_plugin_creator"] = self["webpackChunkjupyterlab_wipp_plugin_creator"] || []).push([["node_modules_deathbeds_jupyterlab-rjsf_lib_fields_jsonobject_index_js"],{

/***/ "./node_modules/@deathbeds/jupyterlab-rjsf/lib/fields/jsonobject/index.js":
/*!********************************************************************************!*\
  !*** ./node_modules/@deathbeds/jupyterlab-rjsf/lib/fields/jsonobject/index.js ***!
  \********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeJSONObjectField": () => (/* binding */ makeJSONObjectField)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _rjsf_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @rjsf/core */ "./node_modules/@rjsf/core/dist/es/index.js");
/* harmony import */ var react_codemirror2__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-codemirror2 */ "./node_modules/@deathbeds/jupyterlab-rjsf/node_modules/react-codemirror2/index.js");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__);

/* order might matter on these imports */
/* first core... */



/**
 * This is a pretty nasty way to deal with the ObjectField being very hard
 * to reach at import time
 *
 * We use the upstream ObjectField at runtime to construct a private class.
 * This could likely be improved with a namespace or something.
 */
function makeJSONObjectField(ObjectField) {
    /**
     * A raw JSON Object which can be stored/edited inside an RJSF
     */
    class JSONObjectField extends ObjectField {
        constructor() {
            super(...arguments);
            this.onReset = () => {
                this._editor.getDoc().setValue(JSON.stringify(this.props.formData, null, 2));
            };
            this.onSave = () => {
                this.props.onChange(this.state.editorValue);
            };
            this.onChange = (editor, data, value) => {
                try {
                    const jsonValue = JSON.parse(value);
                    this.setState({ editorValue: jsonValue, editorError: false });
                }
                catch (err) {
                    this.setState({ editorValue: null, editorError: true });
                }
            };
        }
        render() {
            const { uiSchema, formData, idSchema, name, registry = _rjsf_core__WEBPACK_IMPORTED_MODULE_1__.utils.getDefaultRegistry(), } = this.props;
            const { definitions } = registry;
            const schema = _rjsf_core__WEBPACK_IMPORTED_MODULE_1__.utils.retrieveSchema(this.props.schema, definitions, formData);
            let title;
            if (this.state.wasPropertyKeyModified) {
                title = name;
            }
            else {
                title = schema.title === undefined ? name : schema.title;
            }
            const isLight = !!document.querySelector('body[data-jp-theme-light="true"]');
            const description = uiSchema['ui:description'] || schema.description;
            const { canSave } = this;
            const options = {
                mode: 'application/json',
                theme: isLight ? 'default' : 'zenburn',
                matchBrackets: true,
                autoCloseBrackets: true,
            };
            return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_0__.createElement("legend", null, title),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement("p", { className: "field-description" }, description),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", { className: "jp-SchemaForm-JSONObject-buttons" },
                    react__WEBPACK_IMPORTED_MODULE_0__.createElement("button", { id: `${idSchema.$id}_revert`, className: "jp-JSONEditor-revertButton", title: "Revert to Previous Notebook Metadata", onClick: this.onReset }),
                    react__WEBPACK_IMPORTED_MODULE_0__.createElement("button", { id: `${idSchema.$id}_commit`, disabled: !canSave, className: "jp-JSONEditor-commitButton", title: "Commit to Notebook Metadata", onClick: this.onSave })),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", { id: idSchema.$id },
                    react__WEBPACK_IMPORTED_MODULE_0__.createElement(react_codemirror2__WEBPACK_IMPORTED_MODULE_2__.UnControlled, { editorDidMount: (editor) => (this._editor = editor), value: JSON.stringify(formData, null, 2), options: options, onChange: this.onChange }))));
        }
        get canSave() {
            return (!this.state.editorError &&
                this.state.editorValue &&
                !_lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__.JSONExt.deepEqual(this.state.editorValue, this.props.formData));
        }
    }
    return JSONObjectField;
}
//# sourceMappingURL=index.js.map

/***/ })

}]);
//# sourceMappingURL=node_modules_deathbeds_jupyterlab-rjsf_lib_fields_jsonobject_index_js.d01a1c33003b9d2fa879.js.map